//+------------------------------------------------------------------+
//|                                                   Stochastic RSI |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_minimum    0
#property indicator_maximum    100
#property indicator_color1     Gold
#property indicator_color2     Red
#property indicator_width1     2
#property indicator_style2     STYLE_DASH
#property indicator_levelcolor Green

//
//
//
//
//

extern int    RsiPeriod                  = 8;
extern int    Price                      = PRICE_CLOSE;
extern int    StochasticKPeriod          = 8;
extern int    StochasticSlowing          = 3;
extern int    StochasticSlowingMaMethod  = MODE_EMA;
extern int    StochasticDPeriod          = 8;
extern int    StochasticDMaMethod        = MODE_EMA;
extern double levelOs                    = 20;
extern double levelOb                    = 80; 
extern string __MaMethods                = "";
extern string __0                        = "SMA";
extern string __2                        = "EMA";
extern string __3                        = "Smoothed MA";
extern string __4                        = "Linear weighted MA";
extern string __5                        = "Triangular MA";
extern string __6                        = "Volume weghted MA";
extern string __7                        = "Sine weighted MA";
extern string __8                        = "EPMA";
extern bool   alertsOn                   = true;
extern bool   alertsOnStochRsiCross      = true;
extern bool   alertsOnSignalCross        = true;
extern bool   alertsOnStochCrossSignal   = true;
extern bool   alertsOnCurrent            = true;
extern bool   alertsMessage              = true;
extern bool   alertsSound                = false;
extern bool   alertsNotify               = false;
extern bool   alertsEmail                = false;

extern bool   arrowsVisible              = false;
extern string arrowsIdentifier           = "stochrsi arrows1";
extern double arrowsUpperGap             = 1.0;
extern double arrowsLowerGap             = 1.0;

extern bool   arrowsOnStochRsiCross      = false;
extern color  arrowsStochRsiCrossUpColor = LimeGreen;
extern color  arrowsStochRsiCrossDnColor = Red;
extern int    arrowsStochRsiCrossUpCode  = 241;
extern int    arrowsStochRsiCrossDnCode  = 242;
extern int    arrowsStochRsiCrossSize    = 2;

extern bool   arrowsOnSignCross          = false;
extern color  arrowsSignCrossUpColor     = DeepSkyBlue;
extern color  arrowsSignCrossDnColor     = PaleVioletRed;
extern int    arrowsSignCrossUpCode      = 159;
extern int    arrowsSignCrossDnCode      = 159;
extern int    arrowsSignCrossSize        = 5;

//
//
//
//
//

double stochRsi[];
double stochRsiSignal[];
double rsi[];
double stoch[];
double trend1[];
double trend2[];
double trend3[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,stochRsi);
   SetIndexBuffer(1,stochRsiSignal);
   SetIndexBuffer(2,rsi);
   SetIndexBuffer(3,stoch);
   SetIndexBuffer(4,trend1);
   SetIndexBuffer(5,trend2);
   SetIndexBuffer(6,trend3);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   SetLevelValue(2,5);
   SetLevelValue(3,50);
   SetLevelValue(4,95);

      //
      //
      //
      //
      //
      
      string smooth1 = getAverageName(StochasticSlowingMaMethod);
      string smooth2 = getAverageName(StochasticDMaMethod);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName("StochRsi ("+RsiPeriod+","+StochasticKPeriod+","+StochasticSlowing+","+smooth1+","+StochasticDPeriod+","+smooth2+")");
   return(0);
}
int deinit()
{
   deleteArrows();

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {          
      rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
      double min = rsi[ArrayMinimum(rsi,StochasticKPeriod,i)];
      double max = rsi[ArrayMaximum(rsi,StochasticKPeriod,i)];
                   
      stoch[i] = 0.5; if (min!=max) stoch[i] = 100.0*(rsi[i]-min)/(max-min); 
      stochRsi[i]       = iCMAOnArray(stoch   ,stochRsi      ,StochasticSlowing,StochasticSlowingMaMethod,i);
      stochRsiSignal[i] = iCMAOnArray(stochRsi,stochRsiSignal,StochasticDPeriod,StochasticDMaMethod      ,i); 
                         
      //
      //
      //
      //
      //
                         
      trend1[i] = 0;
      trend2[i] = 0;
      trend3[i] = trend3[i+1];
      if (stochRsi[i]>levelOb)           trend1[i] = 1;
      if (stochRsi[i]<levelOs)           trend1[i] =-1; 
      if (stochRsiSignal[i]>levelOb)     trend2[i] = 1;
      if (stochRsiSignal[i]<levelOs)     trend2[i] =-1; 
      if (stochRsi[i]>stochRsiSignal[i]) trend3[i] = 1;
      if (stochRsi[i]<stochRsiSignal[i]) trend3[i] =-1;
      manageArrow(i);
   }
manageAlerts();   
return(0);
}
           
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//
//
//
//
//

double iCMAOnArray(double& source[], double& result[], int period, int method, int i)
{
   switch(method)
   {
      case 0: return(iSmaOnArray(source,period,i));
      case 1: return(iEmaOnArray(source,result,period,i));
      case 2: return(iSmmaOnArray(source,result,period,i));
      case 3: return(iLwmaOnArray(source,period,i));
      case 4: return(iTmaOnArray(source,period,i));
      case 5: return(iSineWMAOnArray(source,period,i));
      case 6: return(iVolumeWMAOnArray(source,period,i));
      case 7: return(iEPMAOnArray(source,period,i));
   }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iSmaOnArray(double& array[], double period, int i)
{
   double sum = 0; 
   for(int k=0; k<period && (i+k)<Bars; k++) sum += array[i+k];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEmaOnArray(double& source[], double& result[], double period, int i)
{
   double alpha = 2.0 / (1.0+period);
          result[i] = result[i+1]+alpha*(source[i]-result[i+1]);
   return(result[i]);
}
//
//
//
//
//

double iSmmaOnArray(double& source[], double& result[], double period, int i)
{
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (i+k)<Bars; k++) sum += source[i+k];  
         if (k!=0)
               result[i] = sum/k;
         else  result[i] = EMPTY_VALUE;
   }      
   else   result[i] = (result[i+1]*(period-1)+source[i])/period;
   return(result[i]);
}

//
//
//
//
//

double iLwmaOnArray(double& array[], double period, int i)
{
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iTmaOnArray(double& array[], double period, int i)
{
   double half = (period+1.0)/2.0;
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = k+1; if (weight > half) weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

#define Pi 3.14159265358979323846
double iSineWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = MathSin(Pi*(k+1)/(period+1));
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iVolumeWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = Volume[i+k];
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEPMAOnArray(double& array[], int period, int i)
{
   double weight = 2.0*period-1.0;
   double sum    = 0;
   double sumw   = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
       sumw   += weight;
       sum    += weight*array[i+k]; 
       weight -= 3;
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string methodNames[] = {"SMA","EMA","SMMA","LWMA","TriMA","SWMA","VWMA","EPMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,7),0); return(methodNames[method]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnStochRsiCross && trend1[i] != trend1[i+1])
      {
         if (trend1[i+1] == -1 && trend1[i] !=-1) drawArrow("1",0.5,i,arrowsStochRsiCrossUpColor,arrowsStochRsiCrossUpCode,arrowsStochRsiCrossSize,false);
         if (trend1[i+1] ==  1 && trend1[i] != 1) drawArrow("1",0.5,i,arrowsStochRsiCrossDnColor,arrowsStochRsiCrossDnCode,arrowsStochRsiCrossSize, true);
      } 
      if (arrowsOnSignCross && trend2[i] != trend2[i+1])
      {
         if (trend2[i+1] == -1 && trend2[i] !=-1) drawArrow("2",1,i,arrowsSignCrossUpColor,arrowsSignCrossUpCode,arrowsSignCrossSize,false);
         if (trend2[i+1] ==  1 && trend2[i] != 1) drawArrow("2",1,i,arrowsSignCrossDnColor,arrowsSignCrossDnCode,arrowsSignCrossSize, true);
      }                              
   }         
}       

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnStochRsiCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar+1] == 1 && trend1[whichBar] != 1) doAlert(time1,mess1,whichBar," StochRSI crossing overbought down");
            if (trend1[whichBar+1] ==-1 && trend1[whichBar] !=-1) doAlert(time1,mess1,whichBar," StochRSI crossing oversold up");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar+1] == 1 && trend2[whichBar] != 1) doAlert(time2,mess2,whichBar," StochRSI signal crossing overbought down");
            if (trend2[whichBar+1] ==-1 && trend2[whichBar] !=-1) doAlert(time2,mess2,whichBar," StochRSI signal crossing oversold up");
         } 
       static datetime time3 = 0;
       static string   mess3 = "";
         if (alertsOnStochCrossSignal && trend3[whichBar] != trend3[whichBar+1])
         {
            if (trend3[whichBar] == 1) doAlert(time3,mess3,whichBar," StochRSI crossing signal up");
            if (trend3[whichBar] ==-1) doAlert(time3,mess3,whichBar," StochRSI crossing signal down");
         }                           
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," StochRSI "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


